import { Diagnostic } from './diagnostic.js';
import { DiagnosticFix } from './diagnostic-fix.js';
import { Observable } from 'rxjs';
import '../common/range.js';
import '../common/position.js';
import '../common/text-edit.js';

interface DiagnosticsChanged {
    uri: string;
    version?: number;
    diagnostics: Diagnostic[];
}
interface DiagnosticProvider {
    readonly id: string;
    readonly diagnosticsChanged$: Observable<DiagnosticsChanged>;
    init(): Promise<void>;
    getDiagnostics(uri: string): Promise<Diagnostic[]>;
    getDiagnosticFixes(uri: string, diagnostic: Diagnostic): Promise<DiagnosticFix[]>;
}

export type { DiagnosticProvider, DiagnosticsChanged };
