import { Range } from '../common/range.js';
import { Document } from './document.js';
import '../common/position.js';

interface DocumentChange {
    range?: Range;
    text: string;
}
interface DocumentFactory<T extends Document> {
    create(uri: string, format: string, version: number, content: string): T;
    update(document: T, changes: readonly DocumentChange[], version: number): T;
}

export type { DocumentChange, DocumentFactory };
