"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var scripture_document_exports = {};
__export(scripture_document_exports, {
  ScriptureDocument: () => ScriptureDocument,
  ScriptureNodeType: () => ScriptureNodeType,
  findNodes: () => findNodes
});
module.exports = __toCommonJS(scripture_document_exports);
var import_text_document = require('./text-document.cjs');
class ScriptureDocument extends import_text_document.TextDocument {
  constructor(uri, version, content, children) {
    super(uri, version, content);
    this.uri = uri;
    this._children = [];
    this.parent = void 0;
    this.isLeaf = false;
    this.type = 0 /* Document */;
    this.document = this;
    this.range = { start: { line: 0, character: 0 }, end: { line: 0, character: 0 } };
    if (children != null) {
      for (const child of children) {
        this.appendChild(child);
      }
    }
  }
  get children() {
    return this._children;
  }
  updateParent(_parent) {
    throw new Error("The method is not supported.");
  }
  remove() {
    throw new Error("The method is not supported.");
  }
  findNodes(filter) {
    return findNodes(this, filter);
  }
  appendChild(child) {
    this._children.push(child);
    child.updateParent(this);
  }
  insertChild(index, child) {
    this._children.splice(index, 0, child);
    child.updateParent(this);
  }
  removeChild(child) {
    if (child.parent !== this) {
      throw new Error("This node does not contain the specified child.");
    }
    const index = this._children.indexOf(child);
    if (index === -1) {
      throw new Error("This node does not contain the specified child.");
    }
    this._children.splice(index, 1);
    child.updateParent(void 0);
  }
  spliceChildren(start, deleteCount, ...items) {
    const removed = this._children.splice(start, deleteCount, ...items);
    for (const child of removed) {
      child.updateParent(void 0);
    }
    for (const child of items) {
      child.updateParent(this);
    }
  }
  clearChildren() {
    this._children.length = 0;
  }
}
var ScriptureNodeType = /* @__PURE__ */ ((ScriptureNodeType2) => {
  ScriptureNodeType2[ScriptureNodeType2["Document"] = 0] = "Document";
  ScriptureNodeType2[ScriptureNodeType2["Book"] = 1] = "Book";
  ScriptureNodeType2[ScriptureNodeType2["Paragraph"] = 2] = "Paragraph";
  ScriptureNodeType2[ScriptureNodeType2["Chapter"] = 3] = "Chapter";
  ScriptureNodeType2[ScriptureNodeType2["Verse"] = 4] = "Verse";
  ScriptureNodeType2[ScriptureNodeType2["Milestone"] = 5] = "Milestone";
  ScriptureNodeType2[ScriptureNodeType2["Text"] = 6] = "Text";
  ScriptureNodeType2[ScriptureNodeType2["CharacterStyle"] = 7] = "CharacterStyle";
  ScriptureNodeType2[ScriptureNodeType2["Note"] = 8] = "Note";
  ScriptureNodeType2[ScriptureNodeType2["Table"] = 9] = "Table";
  ScriptureNodeType2[ScriptureNodeType2["Row"] = 10] = "Row";
  ScriptureNodeType2[ScriptureNodeType2["Cell"] = 11] = "Cell";
  ScriptureNodeType2[ScriptureNodeType2["Ref"] = 12] = "Ref";
  ScriptureNodeType2[ScriptureNodeType2["OptBreak"] = 13] = "OptBreak";
  ScriptureNodeType2[ScriptureNodeType2["Sidebar"] = 14] = "Sidebar";
  return ScriptureNodeType2;
})(ScriptureNodeType || {});
function* findNodes(node, filter) {
  for (const child of node.children) {
    if (filter == null || Array.isArray(filter) && filter.includes(child.type) || typeof filter === "function" && filter(child) || child.type === filter) {
      yield child;
    }
    yield* findNodes(child, filter);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ScriptureDocument,
  ScriptureNodeType,
  findNodes
});
