class ScriptureLeaf {
  constructor(range = { start: { line: 0, character: 0 }, end: { line: 0, character: 0 } }) {
    this.range = range;
    this.children = [];
    this.isLeaf = true;
  }
  get document() {
    return this._parent?.document;
  }
  get parent() {
    return this._parent;
  }
  updateParent(parent) {
    this._parent = parent;
  }
  remove() {
    if (this._parent == null) {
      throw new Error("The node does not have a parent.");
    }
    this._parent.removeChild(this);
  }
  getText() {
    if (this.document == null) {
      throw new Error("The node is not part of a document.");
    }
    return this.document.getText(this.range);
  }
  *findNodes(_filter) {
  }
  positionAt(offset) {
    if (this.document == null) {
      throw new Error("The node is not part of a document.");
    }
    return this.document.positionAt(offset, this.range);
  }
  appendChild(_child) {
    throw new Error("The method not supported.");
  }
  insertChild(_index, _child) {
    throw new Error("The method not supported.");
  }
  removeChild(_child) {
    throw new Error("The method not supported.");
  }
  spliceChildren(_start, _deleteCount, ..._items) {
    throw new Error("The method not supported.");
  }
  clearChildren() {
    throw new Error("The method not supported.");
  }
}
export {
  ScriptureLeaf
};
