import { Range } from '../common/range.js';
import { ScriptureNodeType } from './scripture-document.js';
import { ScriptureLeaf } from './scripture-leaf.js';
import '../common/position.js';
import './document.js';
import './text-document.js';
import './document-factory.js';

declare class ScriptureMilestone extends ScriptureLeaf {
    readonly style: string;
    readonly isStart: boolean;
    readonly sid?: string | undefined;
    readonly eid?: string | undefined;
    readonly attributes: Record<string, string>;
    constructor(style: string, isStart: boolean, sid?: string | undefined, eid?: string | undefined, attributes?: Record<string, string>, range?: Range);
    get type(): ScriptureNodeType;
}

export { ScriptureMilestone };
