import { ScriptureContainer } from './scripture-container.cjs';
import { ScriptureNodeType, ScriptureNode } from './scripture-document.cjs';
import '../common/position.cjs';
import '../common/range.cjs';
import './document.cjs';
import './text-document.cjs';
import './document-factory.cjs';

declare class ScriptureParagraph extends ScriptureContainer {
    readonly style: string;
    readonly type = ScriptureNodeType.Paragraph;
    readonly attributes: Record<string, string>;
    constructor(style: string, children?: ScriptureNode[]);
    constructor(style: string, attributes?: Record<string, string>, children?: ScriptureNode[]);
}

export { ScriptureParagraph };
