import { ScriptureContainer } from './scripture-container.js';
import { ScriptureNodeType, ScriptureNode } from './scripture-document.js';
import '../common/position.js';
import '../common/range.js';
import './document.js';
import './text-document.js';
import './document-factory.js';

declare class ScriptureParagraph extends ScriptureContainer {
    readonly style: string;
    readonly type = ScriptureNodeType.Paragraph;
    readonly attributes: Record<string, string>;
    constructor(style: string, children?: ScriptureNode[]);
    constructor(style: string, attributes?: Record<string, string>, children?: ScriptureNode[]);
}

export { ScriptureParagraph };
