import { Range } from '../common/range.js';
import { ScriptureNodeType } from './scripture-document.js';
import { ScriptureMilestone } from './scripture-milestone.js';
import '../common/position.js';
import './document.js';
import './text-document.js';
import './document-factory.js';
import './scripture-leaf.js';

declare class ScriptureVerse extends ScriptureMilestone {
    readonly number: string;
    readonly pubNumber?: string | undefined;
    readonly altNumber?: string;
    constructor(number: string, altNumber?: string, pubNumber?: string, sid?: string, eid?: string, range?: Range);
    constructor(number: string, range?: Range);
    get type(): ScriptureNodeType;
}

export { ScriptureVerse };
