import { DocumentFactory, DocumentChange } from './document-factory.cjs';
import { TextDocument } from './text-document.cjs';
import '../common/range.cjs';
import '../common/position.cjs';
import './document.cjs';

declare class TextDocumentFactory implements DocumentFactory<TextDocument> {
    create(uri: string, _format: string, version: number, content: string): TextDocument;
    update(document: TextDocument, changes: readonly DocumentChange[], version: number): TextDocument;
}

export { TextDocumentFactory };
