import { DocumentFactory, DocumentChange } from './document-factory.js';
import { TextDocument } from './text-document.js';
import '../common/range.js';
import '../common/position.js';
import './document.js';

declare class TextDocumentFactory implements DocumentFactory<TextDocument> {
    create(uri: string, _format: string, version: number, content: string): TextDocument;
    update(document: TextDocument, changes: readonly DocumentChange[], version: number): TextDocument;
}

export { TextDocumentFactory };
