import { Position } from '../common/position.cjs';
import { Range } from '../common/range.cjs';
import { Document } from './document.cjs';
import { DocumentChange } from './document-factory.cjs';

declare class TextDocument implements Document {
    readonly uri: string;
    private _lineOffsets;
    private _content;
    private _version;
    constructor(uri: string, version: number, content: string);
    get content(): string;
    get version(): number;
    protected set version(value: number);
    getText(range?: Range): string;
    offsetAt(position: Position): number;
    positionAt(offset: number, range?: Range): Position;
    update(changes: readonly DocumentChange[], version: number): void;
    protected updateContent(change: DocumentChange): void;
    getLineOffsets(): number[];
    ensureBeforeEndOfLine(offset: number, lineOffset: number): number;
}

export { TextDocument };
