import { Position } from '../common/position.cjs';
import { TextEdit } from '../common/text-edit.cjs';
import '../common/range.cjs';

interface OnTypeFormattingProvider {
    readonly id: string;
    readonly onTypeTriggerCharacters: ReadonlySet<string>;
    init(): Promise<void>;
    getOnTypeEdits(uri: string, position: Position, ch: string): Promise<TextEdit[] | undefined>;
}

export type { OnTypeFormattingProvider };
