"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var localizer_exports = {};
__export(localizer_exports, {
  Localizer: () => Localizer
});
module.exports = __toCommonJS(localizer_exports);
var import_i18next = __toESM(require("i18next"), 1);
class Localizer {
  constructor(language) {
    this.backend = new LocalBackend();
    this.i18n = import_i18next.default.createInstance({
      lng: language,
      fallbackLng: "en",
      partialBundledLanguages: true,
      ns: [],
      resources: {}
    }).use(this.backend);
  }
  get language() {
    return this.i18n.language;
  }
  async init() {
    await this.i18n.init();
    await this.i18n.loadNamespaces(Array.from(this.backend.namespaces));
  }
  addNamespace(namespace, loader) {
    if (this.i18n.hasLoadedNamespace(namespace)) {
      return;
    }
    this.backend.addNamespace(namespace, loader);
  }
  async changeLanguage(language) {
    await this.i18n.changeLanguage(language);
  }
  t(key, options) {
    return this.i18n.t(key, options);
  }
}
class LocalBackend {
  constructor() {
    this.namespaceLoaders = /* @__PURE__ */ new Map();
    this.type = "backend";
  }
  get namespaces() {
    return this.namespaceLoaders.keys();
  }
  init(_services, _backendOptions, _i18nextOptions) {
  }
  addNamespace(namespace, loader) {
    this.namespaceLoaders.set(namespace, loader);
  }
  read(language, namespace, callback) {
    const loader = this.namespaceLoaders.get(namespace);
    if (loader == null) {
      callback(new Error(`No loader for namespace ${namespace}`));
      return;
    }
    Promise.resolve(loader(language)).then((data) => {
      if (data != null && typeof data === "object" && "default" in data) {
        data = data.default;
      }
      callback(null, data);
    }).catch(callback);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Localizer
});
